/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.16 from the
 * contents of Raw.xs. Do not edit this file, edit Raw.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Raw.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <inttypes.h>

#include <git2.h>

typedef git_blob * Blob;
typedef git_reference * Branch;
typedef git_commit * Commit;
typedef git_config * Config;
typedef git_cred * Cred;
typedef git_diff_list * Diff;
typedef git_index * Index;
typedef git_push * Push;
typedef git_reference * Reference;
typedef git_refspec * RefSpec;
typedef git_remote * Remote;
typedef git_repository * Repository;
typedef git_signature * Signature;
typedef git_tag * Tag;
typedef git_tree * Tree;
typedef git_tree_entry * TreeEntry;
typedef git_revwalk * Walker;

void xs_object_magic_attach_struct(pTHX_ SV *sv, void *ptr);
void *xs_object_magic_get_struct(pTHX_ SV *sv);

void git_check_error(int err) {
	const git_error *error;

	if (err == GIT_OK)
		return;

	error = giterr_last();

	Perl_croak(aTHX_ "%s", error -> message);
}

SV *git_obj_to_sv(git_object *o, SV *repo_src) {
	SV *res;
	SV *repo;

	switch (git_object_type(o)) {
		case GIT_OBJ_BLOB:
			res = sv_setref_pv(newSV(0), "Git::Raw::Blob", o); break;
		case GIT_OBJ_COMMIT:
			res = sv_setref_pv(newSV(0), "Git::Raw::Commit", o); break;
		case GIT_OBJ_TAG:
			res = sv_setref_pv(newSV(0), "Git::Raw::Tag", o); break;
		case GIT_OBJ_TREE:
			res = sv_setref_pv(newSV(0), "Git::Raw::Tree", o); break;
		default: Perl_croak(aTHX_ "Invalid object type");
	}

	if (sv_isobject(repo_src) &&
	    sv_derived_from(repo_src, "Git::Raw::Repository"))
		repo = SvRV(repo_src);
	else if (sv_isobject(repo_src))
		repo = xs_object_magic_get_struct(aTHX_ SvRV(repo_src));
	else
		Perl_croak(aTHX_ "Invalid repository source");

	if (!repo)
		Perl_croak(aTHX_ "Invalid repository source");

	xs_object_magic_attach_struct(aTHX_ SvRV(res), SvREFCNT_inc_NN(repo));

	return res;
}

git_object *git_sv_to_obj(SV *sv) {
	if (sv_isobject(sv) &&
		(sv_derived_from(sv, "Git::Raw::Blob") ||
		sv_derived_from(sv, "Git::Raw::Commit") ||
		sv_derived_from(sv, "Git::Raw::Tag") ||
		sv_derived_from(sv, "Git::Raw::Tree"))
	)
		return INT2PTR(git_object *, SvIV((SV *) SvRV(sv)));

	return NULL;
}

#define GIT_SV_TO_PTR(type, sv) ({					\
	void *ptr;							\
									\
	if (sv_isobject(sv) && sv_derived_from(sv, "Git::Raw::" #type))	\
		ptr = INT2PTR(void *, SvIV((SV *) SvRV(sv)));		\
	else								\
		Perl_croak(aTHX_ "Argument is not of type Git::Raw::" #type); \
									\
	ptr;								\
})

SV *git_oid_to_sv(git_oid *oid) {
	char out[41];

	git_oid_fmt(out, oid);
	out[40] = '\0';

	return newSVpv(out, 0);
}

#define GIT_CHECKOUT_OPT(HV, NAME, MASK) ({				\
	SV **opt;							\
									\
	if ((opt = hv_fetchs(HV, NAME, 0)) && (SvIV(*opt) != 0)) {	\
		out |= MASK;						\
	}								\
})

unsigned git_hv_to_checkout_strategy(HV *strategy) {
	unsigned out = 0;

	GIT_CHECKOUT_OPT(
		strategy, "none", GIT_CHECKOUT_NONE
	);

	GIT_CHECKOUT_OPT(
		strategy, "force", GIT_CHECKOUT_FORCE
	);

	GIT_CHECKOUT_OPT(
		strategy, "safe", GIT_CHECKOUT_SAFE
	);

	GIT_CHECKOUT_OPT(
		strategy, "safe_create", GIT_CHECKOUT_SAFE_CREATE
	);

	GIT_CHECKOUT_OPT(
		strategy, "allow_conflicts", GIT_CHECKOUT_ALLOW_CONFLICTS
	);

	GIT_CHECKOUT_OPT(
		strategy, "remove_untracked", GIT_CHECKOUT_REMOVE_UNTRACKED
	);

	GIT_CHECKOUT_OPT(
		strategy, "remove_ignored", GIT_CHECKOUT_REMOVE_IGNORED
	);

	GIT_CHECKOUT_OPT(
		strategy, "update_only", GIT_CHECKOUT_UPDATE_ONLY
	);

	GIT_CHECKOUT_OPT(
		strategy, "dont_update_index", GIT_CHECKOUT_DONT_UPDATE_INDEX
	);

	GIT_CHECKOUT_OPT(
		strategy, "no_refresh", GIT_CHECKOUT_NO_REFRESH
	);

	GIT_CHECKOUT_OPT(
		strategy, "skip_unmerged",    GIT_CHECKOUT_SKIP_UNMERGED
	);

	return out;
}

int git_diff_cb(const git_diff_delta *delta, const git_diff_range *range,
		char usage, const char *line, size_t line_len, void *data) {
	dSP;

	SV *coderef = data;

	ENTER;
	SAVETMPS;

	PUSHMARK(SP);
	switch (usage) {
		case GIT_DIFF_LINE_CONTEXT:
			XPUSHs(sv_2mortal(newSVpv("ctx", 0))); break;

		case GIT_DIFF_LINE_ADDITION:
		case GIT_DIFF_LINE_ADD_EOFNL:
			XPUSHs(sv_2mortal(newSVpv("add", 0))); break;

		case GIT_DIFF_LINE_DELETION:
		case GIT_DIFF_LINE_DEL_EOFNL:
			XPUSHs(sv_2mortal(newSVpv("del", 0))); break;

		case GIT_DIFF_LINE_FILE_HDR:
			XPUSHs(sv_2mortal(newSVpv("file", 0))); break;

		case GIT_DIFF_LINE_HUNK_HDR:
			XPUSHs(sv_2mortal(newSVpv("hunk", 0))); break;

		case GIT_DIFF_LINE_BINARY:
			XPUSHs(sv_2mortal(newSVpv("bin", 0))); break;

		default: Perl_croak(aTHX_ "Unexpected diff usage");
	}

	XPUSHs(sv_2mortal(newSVpv(line, line_len)));
	PUTBACK;

	call_sv(coderef, G_DISCARD);

	FREETMPS;
	LEAVE;

	return 0;
}

typedef struct {
	Repository repo_ptr;
	SV *repo;
	SV *cb;
	const char *class;
} git_foreach_payload;

int git_branch_foreach_cbb(const char *name, git_branch_t type, void *payload) {
	dSP;
	int rv;
	Branch branch;
	SV *repo, *cb_arg;
	git_foreach_payload *pl = payload;

	int rc = git_branch_lookup(&branch, pl -> repo_ptr, name, type);
	git_check_error(rc);

	ENTER;
	SAVETMPS;

	repo = SvRV(((git_foreach_payload *) payload) -> repo);

	cb_arg = sv_newmortal();

	sv_setref_pv(cb_arg, pl -> class, (void *) branch);
	xs_object_magic_attach_struct(aTHX_ SvRV(cb_arg), SvREFCNT_inc_NN(repo));

	PUSHMARK(SP);
	PUSHs(cb_arg);
	PUTBACK;

	call_sv(pl -> cb, G_SCALAR);

	SPAGAIN;

	rv = POPi;

	FREETMPS;
	LEAVE;

	return rv;
}

int git_config_foreach_cbb(const git_config_entry *entry, void *payload) {
	dSP;
	int rv;

	ENTER;
	SAVETMPS;

	PUSHMARK(SP);
	PUSHs(newSVpv(entry -> name, 0));
	PUSHs(newSVpv(entry -> value, 0));
	PUSHs(newSVuv(entry -> level));
	PUTBACK;

	call_sv(((git_foreach_payload *) payload) -> cb, G_SCALAR);

	SPAGAIN;

	rv = POPi;

	FREETMPS;
	LEAVE;

	return rv;
}

int git_stash_foreach_cb(size_t i, const char *msg, const git_oid *oid, void *payload) {
	dSP;
	int rv;

	ENTER;
	SAVETMPS;

	PUSHMARK(SP);
	PUSHs(newSVuv(i));
	PUSHs(newSVpv(msg, 0));
	PUSHs(git_oid_to_sv((git_oid *) oid));
	PUTBACK;

	call_sv(((git_foreach_payload *) payload) -> cb, G_SCALAR);

	SPAGAIN;

	rv = POPi;

	FREETMPS;
	LEAVE;

	return rv;
}

int git_tag_foreach_cbb(const char *name, git_oid *oid, void *payload) {
	dSP;
	int rv;
	Tag tag;
	SV *repo, *cb_arg;
	git_foreach_payload *pl = payload;

	int rc = git_tag_lookup(&tag, pl -> repo_ptr, oid);
	git_check_error(rc);

	ENTER;
	SAVETMPS;

	repo = SvRV(pl -> repo);

	cb_arg = sv_newmortal();
	sv_setref_pv(cb_arg, pl -> class, (void *) tag);
	xs_object_magic_attach_struct(aTHX_ SvRV(cb_arg), SvREFCNT_inc_NN(repo));

	PUSHMARK(SP);
	PUSHs(cb_arg);
	PUTBACK;

	call_sv(pl -> cb, G_SCALAR);

	SPAGAIN;

	rv = POPi;

	FREETMPS;
	LEAVE;

	return rv;
}

int git_cred_acquire_cbb(git_cred **cred, const char *url,
		const char *usr_from_url, unsigned int allow, void *cb) {
	dSP;
	SV *creds;

	ENTER;
	SAVETMPS;

	PUSHMARK(SP);
	PUSHs(newSVpv(url, 0));
	PUTBACK;

	call_sv(cb, G_SCALAR);

	SPAGAIN;

	creds = POPs;

	*cred = GIT_SV_TO_PTR(Cred, creds);

	FREETMPS;
	LEAVE;

	return 0;
}

STATIC MGVTBL null_mg_vtbl = {
	NULL, /* get */
	NULL, /* set */
	NULL, /* len */
	NULL, /* clear */
	NULL, /* free */
#if MGf_COPY
	NULL, /* copy */
#endif /* MGf_COPY */
#if MGf_DUP
	NULL, /* dup */
#endif /* MGf_DUP */
#if MGf_LOCAL
	NULL, /* local */
#endif /* MGf_LOCAL */
};

void xs_object_magic_attach_struct(pTHX_ SV *sv, void *ptr) {
	sv_magicext(sv, NULL, PERL_MAGIC_ext, &null_mg_vtbl, ptr, 0);
}

STATIC MAGIC *xs_object_magic_get_mg(pTHX_ SV *sv) {
	MAGIC *mg;

	if (SvTYPE(sv) >= SVt_PVMG) {
		for (mg = SvMAGIC(sv); mg; mg = mg->mg_moremagic) {
			if ((mg->mg_type == PERL_MAGIC_ext) &&
			    (mg->mg_virtual == &null_mg_vtbl))
				return mg;
		}
	}

	return NULL;
}

void *xs_object_magic_get_struct(pTHX_ SV *sv) {
	MAGIC *mg = xs_object_magic_get_mg(aTHX_ sv);

	return (mg) ? mg -> mg_ptr : NULL;
}

#define GIT_SV_TO_REPO(SV) ({				\
	xs_object_magic_get_struct(aTHX_ SvRV(SV));	\
})

#define GIT_NEW_OBJ(rv, class, sv, magic)			\
	STMT_START {						\
		(rv) = sv_setref_pv(newSV(0), class, sv);	\
								\
		xs_object_magic_attach_struct(			\
			aTHX_ SvRV(rv), SvREFCNT_inc_NN(magic)	\
		);						\
	} STMT_END

#line 426 "Raw.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)    S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage        S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 568 "Raw.c"

/* INCLUDE:  Including 'xs/Blob.xs' from 'Raw.xs' */


/* INCLUDE:  Including 'xs/Branch.xs' from 'xs/Blob.xs' */


/* INCLUDE:  Including 'xs/Commit.xs' from 'xs/Branch.xs' */


/* INCLUDE:  Including 'xs/Config.xs' from 'xs/Commit.xs' */


/* INCLUDE:  Including 'xs/Cred.xs' from 'xs/Config.xs' */


/* INCLUDE:  Including 'xs/Diff.xs' from 'xs/Cred.xs' */


/* INCLUDE:  Including 'xs/Index.xs' from 'xs/Diff.xs' */


/* INCLUDE:  Including 'xs/Push.xs' from 'xs/Index.xs' */


/* INCLUDE:  Including 'xs/Reference.xs' from 'xs/Push.xs' */


/* INCLUDE:  Including 'xs/RefSpec.xs' from 'xs/Reference.xs' */


/* INCLUDE:  Including 'xs/Remote.xs' from 'xs/RefSpec.xs' */


/* INCLUDE:  Including 'xs/Repository.xs' from 'xs/Remote.xs' */


/* INCLUDE:  Including 'xs/Signature.xs' from 'xs/Repository.xs' */


/* INCLUDE:  Including 'xs/Stash.xs' from 'xs/Signature.xs' */


/* INCLUDE:  Including 'xs/Tag.xs' from 'xs/Stash.xs' */


/* INCLUDE:  Including 'xs/Tree.xs' from 'xs/Tag.xs' */


/* INCLUDE:  Including 'xs/TreeEntry.xs' from 'xs/Tree.xs' */


/* INCLUDE:  Including 'xs/Walker.xs' from 'xs/TreeEntry.xs' */


XS_EUPXS(XS_Git__Raw__Walker_create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Walker_create)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "class, repo");
    {
	SV *	class = ST(0)
;
	Repository	repo;
	SV *	RETVAL;

	if (sv_isobject(ST(1)) && sv_derived_from(ST(1), "Git::Raw::Repository"))
		repo = INT2PTR(Repository, SvIV((SV *) SvRV(ST(1))));
	else
		Perl_croak(aTHX_ "repo is not of type Git::Raw::Repository")
;
#line 9 "./xs/Walker.xs"
		Walker walk;

		int rc = git_revwalk_new(&walk, repo);
		git_check_error(rc);

		RETVAL = sv_setref_pv(newSV(0), SvPVbyte_nolen(class), walk);

#line 649 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Walker_push); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Walker_push)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, commit");
    {
	Walker	self;
	Commit	commit;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Walker"))
		self = INT2PTR(Walker, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Walker")
;

	if (sv_isobject(ST(1)) && sv_derived_from(ST(1), "Git::Raw::Commit"))
		commit = INT2PTR(Commit, SvIV((SV *) SvRV(ST(1))));
	else
		Perl_croak(aTHX_ "commit is not of type Git::Raw::Commit")
;
#line 24 "./xs/Walker.xs"
		int rc = git_revwalk_push(self, git_commit_id(commit));
		git_check_error(rc);
#line 681 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Walker_push_glob); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Walker_push_glob)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, glob");
    {
	Walker	self;
	char*	glob = (char *)SvPV_nolen(ST(1))
;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Walker"))
		self = INT2PTR(Walker, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Walker")
;
#line 33 "./xs/Walker.xs"
		int rc = git_revwalk_push_glob(self, glob);
		git_check_error(rc);
#line 706 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Walker_push_ref); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Walker_push_ref)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, ref");
    {
	Walker	self;
	char*	ref = (char *)SvPV_nolen(ST(1))
;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Walker"))
		self = INT2PTR(Walker, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Walker")
;
#line 42 "./xs/Walker.xs"
		int rc = git_revwalk_push_ref(self, ref);
		git_check_error(rc);
#line 731 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Walker_push_head); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Walker_push_head)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Walker	self;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Walker"))
		self = INT2PTR(Walker, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Walker")
;
#line 50 "./xs/Walker.xs"
		int rc = git_revwalk_push_head(self);
		git_check_error(rc);
#line 754 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Walker_hide); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Walker_hide)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, commit");
    {
	Walker	self;
	Commit	commit;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Walker"))
		self = INT2PTR(Walker, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Walker")
;

	if (sv_isobject(ST(1)) && sv_derived_from(ST(1), "Git::Raw::Commit"))
		commit = INT2PTR(Commit, SvIV((SV *) SvRV(ST(1))));
	else
		Perl_croak(aTHX_ "commit is not of type Git::Raw::Commit")
;
#line 59 "./xs/Walker.xs"
		int rc = git_revwalk_hide(self, git_commit_id(commit));
		git_check_error(rc);
#line 784 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Walker_hide_glob); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Walker_hide_glob)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, glob");
    {
	Walker	self;
	char*	glob = (char *)SvPV_nolen(ST(1))
;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Walker"))
		self = INT2PTR(Walker, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Walker")
;
#line 68 "./xs/Walker.xs"
		int rc = git_revwalk_hide_glob(self, glob);
		git_check_error(rc);
#line 809 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Walker_hide_ref); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Walker_hide_ref)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, ref");
    {
	Walker	self;
	char*	ref = (char *)SvPV_nolen(ST(1))
;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Walker"))
		self = INT2PTR(Walker, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Walker")
;
#line 77 "./xs/Walker.xs"
		int rc = git_revwalk_hide_ref(self, ref);
		git_check_error(rc);
#line 834 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Walker_hide_head); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Walker_hide_head)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Walker	self;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Walker"))
		self = INT2PTR(Walker, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Walker")
;
#line 85 "./xs/Walker.xs"
		int rc = git_revwalk_hide_head(self);
		git_check_error(rc);
#line 857 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Walker_next); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Walker_next)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Walker	self;
	Commit	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Walker"))
		self = INT2PTR(Walker, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Walker")
;
#line 93 "./xs/Walker.xs"
		git_oid oid;
		Commit commit;
		int rc = git_revwalk_next(&oid, self);

		switch (rc) {
			case 0: {
				Repository repo = git_revwalk_repository(self);

				rc = git_commit_lookup(&commit, repo, &oid);
				git_check_error(rc);

				break;
			}

			case GIT_ITEROVER: XSRETURN_UNDEF;

			default: git_check_error(rc);
		}

		RETVAL = commit;

#line 900 "Raw.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Git::Raw::Commit", (void *) RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Walker_reset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Walker_reset)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Walker	self;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Walker"))
		self = INT2PTR(Walker, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Walker")
;
#line 121 "./xs/Walker.xs"
		git_revwalk_reset(self);
#line 924 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Walker_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Walker_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Walker	self;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Walker"))
		self = INT2PTR(Walker, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Walker")
;
#line 128 "./xs/Walker.xs"
		git_revwalk_free(self);
#line 946 "Raw.c"
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'xs/TreeEntry.xs' from 'xs/Walker.xs' */


XS_EUPXS(XS_Git__Raw__TreeEntry_id); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__TreeEntry_id)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	TreeEntry	self;
	SV *	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::TreeEntry"))
		self = INT2PTR(TreeEntry, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::TreeEntry")
;
#line 8 "./xs/TreeEntry.xs"
		const git_oid *oid = git_tree_entry_id(self);
		RETVAL = git_oid_to_sv((git_oid *) oid);

#line 974 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__TreeEntry_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__TreeEntry_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	TreeEntry	self;
	SV *	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::TreeEntry"))
		self = INT2PTR(TreeEntry, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::TreeEntry")
;
#line 18 "./xs/TreeEntry.xs"
		const char *name = git_tree_entry_name(self);
		RETVAL = newSVpv(name, 0);

#line 1001 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__TreeEntry_object); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__TreeEntry_object)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 28 "./xs/TreeEntry.xs"
		git_object *obj;
		TreeEntry self_ptr = GIT_SV_TO_PTR(TreeEntry, self);
		Repository repo = INT2PTR(
			Repository,
			SvIV((SV *)xs_object_magic_get_struct(aTHX_ SvRV(self)))
		);

		int rc = git_tree_entry_to_object(&obj, repo, self_ptr);
		git_check_error(rc);

		RETVAL = git_obj_to_sv(obj, self);

#line 1032 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__TreeEntry_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__TreeEntry_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 47 "./xs/TreeEntry.xs"
		git_tree_entry_free(GIT_SV_TO_PTR(TreeEntry, self));
		SvREFCNT_dec(xs_object_magic_get_struct(aTHX_ SvRV(self)));
#line 1052 "Raw.c"
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'xs/Tree.xs' from 'xs/TreeEntry.xs' */


XS_EUPXS(XS_Git__Raw__Tree_lookup); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Tree_lookup)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "class, repo, id");
    {
	SV *	class = ST(0)
;
	SV *	repo = ST(1)
;
	SV *	id = ST(2)
;
	SV *	RETVAL;
#line 10 "./xs/Tree.xs"
		Tree tree;
		git_oid oid;

		STRLEN len;
		const char *id_str = SvPVbyte(id, len);
		Repository repo_ptr = GIT_SV_TO_PTR(Repository, repo);

		int rc = git_oid_fromstrn(&oid, id_str, len);
		git_check_error(rc);

		rc = git_tree_lookup_prefix(&tree, repo_ptr, &oid, len);
		git_check_error(rc);

		GIT_NEW_OBJ(RETVAL, SvPVbyte_nolen(class), tree, SvRV(repo));

#line 1091 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Tree_id); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Tree_id)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tree	self;
	SV *	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Tree"))
		self = INT2PTR(Tree, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Tree")
;
#line 32 "./xs/Tree.xs"
		const git_oid *oid = git_tree_id(self);
		RETVAL = git_oid_to_sv((git_oid *) oid);

#line 1118 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Tree_entries); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Tree_entries)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	AV *	RETVAL;
#line 42 "./xs/Tree.xs"
		SV *repo = GIT_SV_TO_REPO(self);

		AV *entries = newAV();
		Tree self_ptr = GIT_SV_TO_PTR(Tree, self);
		int i, count = git_tree_entrycount(self_ptr);

		for (i = 0; i < count; i++) {
			SV *tmp;
			TreeEntry entry = (TreeEntry) git_tree_entry_byindex(self_ptr, i);

			GIT_NEW_OBJ(
				tmp, "Git::Raw::TreeEntry",
				git_tree_entry_dup(entry), repo
			);

			av_push(entries, tmp);
		}

		RETVAL = entries;

#line 1157 "Raw.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Tree_entry_byname); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Tree_entry_byname)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, name");
    {
	SV *	self = ST(0)
;
	SV *	name = ST(1)
;
	SV *	RETVAL;
#line 70 "./xs/Tree.xs"
		SV *repo = GIT_SV_TO_REPO(self);

		STRLEN len;
		const char *name_str = SvPVbyte(name, len);

		TreeEntry entry = (TreeEntry) git_tree_entry_byname(
			GIT_SV_TO_PTR(Tree, self), name_str
		);

		if (!entry) Perl_croak(aTHX_ "Invalid name");

		GIT_NEW_OBJ(
			RETVAL, "Git::Raw::TreeEntry",
			git_tree_entry_dup(entry), repo
		);

#line 1194 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Tree_entry_bypath); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Tree_entry_bypath)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, path");
    {
	SV *	self = ST(0)
;
	SV *	path = ST(1)
;
	SV *	RETVAL;
#line 94 "./xs/Tree.xs"
		SV *repo = GIT_SV_TO_REPO(self);

		int rc;
		STRLEN len;
		const char *path_str = SvPVbyte(path, len);

		TreeEntry entry;

		rc = git_tree_entry_bypath(
			&entry, GIT_SV_TO_PTR(Tree, self), path_str
		);
		git_check_error(rc);

		GIT_NEW_OBJ(RETVAL, "Git::Raw::TreeEntry", entry, repo);

#line 1230 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Tree_diff); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Tree_diff)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	Tree	self;
	Diff	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Tree"))
		self = INT2PTR(Tree, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Tree")
;
#line 117 "./xs/Tree.xs"
		int rc;
		Diff diff;

		switch (items) {
			case 1: {
				rc = git_diff_tree_to_workdir(
					&diff, git_tree_owner(self), self, NULL
				);
				git_check_error(rc);

				break;
			}

			case 2: {
				Tree new = GIT_SV_TO_PTR(Tree, ST(1));

				rc = git_diff_tree_to_tree(
					&diff, git_tree_owner(self), self, new, NULL
				);
				git_check_error(rc);

				break;
			}

			default: Perl_croak(aTHX_ "Wrong number of arguments");
		}

		RETVAL = diff;

#line 1283 "Raw.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Git::Raw::Diff", (void *) RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Tree_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Tree_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 153 "./xs/Tree.xs"
		git_tree_free(GIT_SV_TO_PTR(Tree, self));
		SvREFCNT_dec(xs_object_magic_get_struct(aTHX_ SvRV(self)));
#line 1303 "Raw.c"
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'xs/Tag.xs' from 'xs/Tree.xs' */


XS_EUPXS(XS_Git__Raw__Tag_create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Tag_create)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "class, repo, name, msg, tagger, target");
    {
	SV *	class = ST(0)
;
	SV *	repo = ST(1)
;
	SV *	name = ST(2)
;
	SV *	msg = ST(3)
;
	Signature	tagger;
	SV *	target = ST(5)
;
	SV *	RETVAL;

	if (sv_isobject(ST(4)) && sv_derived_from(ST(4), "Git::Raw::Signature"))
		tagger = INT2PTR(Signature, SvIV((SV *) SvRV(ST(4))));
	else
		Perl_croak(aTHX_ "tagger is not of type Git::Raw::Signature")
;
#line 13 "./xs/Tag.xs"
		Tag tag;

		git_oid oid;
		git_object *obj;
		Repository r = GIT_SV_TO_PTR(Repository, repo);

		obj = git_sv_to_obj(target);

		if (obj == NULL)
			Perl_croak(aTHX_ "target is not of a valid type");

		int rc = git_tag_create(
			&oid, r, SvPVbyte_nolen(name),
			obj, tagger, SvPVbyte_nolen(msg), 0
		);
		git_check_error(rc);

		rc = git_tag_lookup(&tag, r, &oid);
		git_check_error(rc);

		GIT_NEW_OBJ(RETVAL, SvPVbyte_nolen(class), tag, SvRV(repo));

#line 1360 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Tag_lookup); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Tag_lookup)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "class, repo, id");
    {
	SV *	class = ST(0)
;
	SV *	repo = ST(1)
;
	SV *	id = ST(2)
;
	SV *	RETVAL;
#line 44 "./xs/Tag.xs"
		Tag tag;
		git_oid oid;

		STRLEN len;
		const char *id_str = SvPVbyte(id, len);
		Repository repo_ptr = GIT_SV_TO_PTR(Repository, repo);

		int rc = git_oid_fromstrn(&oid, id_str, len);
		git_check_error(rc);

		rc = git_tag_lookup_prefix(&tag, repo_ptr, &oid, len);
		git_check_error(rc);

		GIT_NEW_OBJ(RETVAL, SvPVbyte_nolen(class), tag, SvRV(repo));

#line 1398 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Tag_foreach); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Tag_foreach)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "class, repo, cb");
    {
	SV *	class = ST(0)
;
	SV *	repo = ST(1)
;
	SV *	cb = ST(2)
;
#line 68 "./xs/Tag.xs"
		git_foreach_payload payload = {
			.repo_ptr = GIT_SV_TO_PTR(Repository, repo),
			.repo     = repo,
			.cb       = cb,
			.class    = SvPVbyte_nolen(class)
		};

		int rc = git_tag_foreach(payload.repo_ptr, git_tag_foreach_cbb, &payload);

		if (rc != GIT_EUSER)
			git_check_error(rc);
#line 1431 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Tag_delete); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Tag_delete)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 85 "./xs/Tag.xs"
		Tag tag_ptr = GIT_SV_TO_PTR(Tag, self);

		Repository repo = INT2PTR(
			Repository, SvIV((SV *) GIT_SV_TO_REPO(self))
		);

		int rc = git_tag_delete(repo, git_tag_name(tag_ptr));
		git_check_error(rc);

		git_tag_free(tag_ptr);
		sv_setiv(SvRV(self), 0);
#line 1458 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Tag_id); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Tag_id)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tag	self;
	SV *	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Tag"))
		self = INT2PTR(Tag, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Tag")
;
#line 102 "./xs/Tag.xs"
		const git_oid *oid = git_tag_id(self);
		RETVAL = git_oid_to_sv((git_oid *) oid);

#line 1483 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Tag_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Tag_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tag	self;
	SV *	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Tag"))
		self = INT2PTR(Tag, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Tag")
;
#line 112 "./xs/Tag.xs"
		const char *msg = git_tag_name(self);
		RETVAL = newSVpv(msg, 0);

#line 1510 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Tag_message); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Tag_message)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tag	self;
	SV *	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Tag"))
		self = INT2PTR(Tag, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Tag")
;
#line 122 "./xs/Tag.xs"
		const char *msg = git_tag_message(self);
		RETVAL = newSVpv(msg, 0);

#line 1537 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Tag_tagger); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Tag_tagger)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tag	self;
	Signature	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Tag"))
		self = INT2PTR(Tag, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Tag")
;
#line 132 "./xs/Tag.xs"
		Signature c = (Signature) git_tag_tagger(self);
		RETVAL = git_signature_dup(c);

#line 1564 "Raw.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Git::Raw::Signature", (void *) RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Tag_target); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Tag_target)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 142 "./xs/Tag.xs"
		git_object *obj;

		int rc = git_tag_target(&obj, GIT_SV_TO_PTR(Tag, self));
		git_check_error(rc);

		RETVAL = git_obj_to_sv(obj, self);

#line 1590 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Tag_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Tag_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 156 "./xs/Tag.xs"
		git_tag_free(GIT_SV_TO_PTR(Tag, self));
		SvREFCNT_dec(xs_object_magic_get_struct(aTHX_ SvRV(self)));
#line 1610 "Raw.c"
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'xs/Stash.xs' from 'xs/Tag.xs' */


XS_EUPXS(XS_Git__Raw__Stash_save); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Stash_save)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "class, repo, stasher, msg");
    {
	SV *	class = ST(0)
;
	Repository	repo;
	Signature	stasher;
	SV *	msg = ST(3)
;

	if (sv_isobject(ST(1)) && sv_derived_from(ST(1), "Git::Raw::Repository"))
		repo = INT2PTR(Repository, SvIV((SV *) SvRV(ST(1))));
	else
		Perl_croak(aTHX_ "repo is not of type Git::Raw::Repository")
;

	if (sv_isobject(ST(2)) && sv_derived_from(ST(2), "Git::Raw::Signature"))
		stasher = INT2PTR(Signature, SvIV((SV *) SvRV(ST(2))));
	else
		Perl_croak(aTHX_ "stasher is not of type Git::Raw::Signature")
;
#line 11 "./xs/Stash.xs"
		git_oid oid;
		const char *message = SvPVbyte_nolen(msg);

		int rc = git_stash_save(&oid, repo, stasher, message, 0);
		git_check_error(rc);
#line 1650 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Stash_foreach); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Stash_foreach)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "class, repo, cb");
    {
	SV *	class = ST(0)
;
	SV *	repo = ST(1)
;
	SV *	cb = ST(2)
;
#line 24 "./xs/Stash.xs"
		git_foreach_payload payload = {
			.repo_ptr = GIT_SV_TO_PTR(Repository, repo),
			.repo     = repo,
			.cb       = cb
		};

		int rc = git_stash_foreach(
			payload.repo_ptr, git_stash_foreach_cb, &payload
		);

		git_check_error(rc);
#line 1681 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Stash_drop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Stash_drop)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "class, repo, index");
    {
	SV *	class = ST(0)
;
	Repository	repo;
	size_t	index = (size_t)SvUV(ST(2))
;

	if (sv_isobject(ST(1)) && sv_derived_from(ST(1), "Git::Raw::Repository"))
		repo = INT2PTR(Repository, SvIV((SV *) SvRV(ST(1))));
	else
		Perl_croak(aTHX_ "repo is not of type Git::Raw::Repository")
;
#line 43 "./xs/Stash.xs"
		int rc = git_stash_drop(repo, index);
		git_check_error(rc);
#line 1708 "Raw.c"
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'xs/Signature.xs' from 'xs/Stash.xs' */


XS_EUPXS(XS_Git__Raw__Signature_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Signature_new)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "class, name, email, time, off");
    {
	SV *	class = ST(0)
;
	SV *	name = ST(1)
;
	SV *	email = ST(2)
;
	SV *	time = ST(3)
;
	unsigned	off = (unsigned)SvUV(ST(4))
;
	Signature	RETVAL;
#line 12 "./xs/Signature.xs"
		Signature sig;

		git_time_t git_time;
		sscanf(SvPVbyte_nolen(time), "%" PRId64, &git_time);

		int rc = git_signature_new(
			&sig, SvPVbyte_nolen(name),
			SvPVbyte_nolen(email), git_time, off
		);
		git_check_error(rc);

		RETVAL = sig;

#line 1749 "Raw.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Git::Raw::Signature", (void *) RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Signature_now); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Signature_now)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "class, name, email");
    {
	SV *	class = ST(0)
;
	SV *	name = ST(1)
;
	SV *	email = ST(2)
;
	Signature	RETVAL;
#line 34 "./xs/Signature.xs"
		Signature sig;

		int rc = git_signature_now(
			&sig, SvPVbyte_nolen(name), SvPVbyte_nolen(email)
		);
		git_check_error(rc);

		RETVAL = sig;

#line 1781 "Raw.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Git::Raw::Signature", (void *) RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Signature_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Signature_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Signature	self;
	SV *	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Signature"))
		self = INT2PTR(Signature, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Signature")
;
#line 50 "./xs/Signature.xs"
		RETVAL = newSVpv(self -> name, 0);

#line 1807 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Signature_email); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Signature_email)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Signature	self;
	SV *	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Signature"))
		self = INT2PTR(Signature, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Signature")
;
#line 59 "./xs/Signature.xs"
		RETVAL = newSVpv(self -> email, 0);

#line 1833 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Signature_time); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Signature_time)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Signature	self;
	SV *	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Signature"))
		self = INT2PTR(Signature, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Signature")
;
#line 68 "./xs/Signature.xs"
		git_time_t time = self -> when.time;

		const int n = snprintf(NULL, 0, "%" PRId64, time);
		char buf[n + 1];

		snprintf(buf, n + 1, "%" PRId64, time);

		RETVAL = newSVpv(buf, 0);

#line 1866 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Signature_offset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Signature_offset)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Signature	self;
	int	RETVAL;
	dXSTARG;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Signature"))
		self = INT2PTR(Signature, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Signature")
;
#line 84 "./xs/Signature.xs"
		RETVAL = self -> when.offset;

#line 1893 "Raw.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Signature_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Signature_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Signature	self;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Signature"))
		self = INT2PTR(Signature, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Signature")
;
#line 92 "./xs/Signature.xs"
		git_signature_free(self);
#line 1916 "Raw.c"
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'xs/Repository.xs' from 'xs/Signature.xs' */


XS_EUPXS(XS_Git__Raw__Repository_init); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Repository_init)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "class, path, is_bare");
    {
	SV *	class = ST(0)
;
	SV *	path = ST(1)
;
	unsigned	is_bare = (unsigned)SvUV(ST(2))
;
	SV *	RETVAL;
#line 10 "./xs/Repository.xs"
		Repository repo;

		int rc = git_repository_init(
			&repo, SvPVbyte_nolen(path), is_bare
		);
		git_check_error(rc);

		RETVAL = sv_setref_pv(newSV(0), SvPVbyte_nolen(class), repo);

#line 1949 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Repository_clone); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Repository_clone)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "class, url, path, opts");
    {
	SV *	class = ST(0)
;
	SV *	url = ST(1)
;
	SV *	path = ST(2)
;
	HV *	opts;
	SV *	RETVAL;

	STMT_START {
		SV* const xsub_tmp_sv = ST(3);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    opts = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak(aTHX_ "%s: %s is not a HASH reference",
				"Git::Raw::Repository::clone",
				"opts");
		}
	} STMT_END
;
#line 29 "./xs/Repository.xs"
		int rc;
		SV **opt;
		Repository repo;

		git_clone_options clone_opts = GIT_CLONE_OPTIONS_INIT;

		/* Bare repository */
		if ((opt = hv_fetchs(opts, "bare", 0)) && (SvIV(*opt) != 0))
			clone_opts.bare = 1;
		else
			clone_opts.bare = 0;

		/* Cred acquire */
		if ((opt = hv_fetchs(opts, "cred_acquire", 0))) {
			SV *cb = *opt;

			SvREFCNT_inc(cb);

			clone_opts.cred_acquire_cb = git_cred_acquire_cbb;
			clone_opts.cred_acquire_payload = cb;
		}

		rc = git_clone(
			&repo, SvPVbyte_nolen(url), SvPVbyte_nolen(path),
			&clone_opts
		);

		git_check_error(rc);

		RETVAL = sv_setref_pv(newSV(0), SvPVbyte_nolen(class), repo);

#line 2018 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Repository_open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Repository_open)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "class, path");
    {
	SV *	class = ST(0)
;
	SV *	path = ST(1)
;
	SV *	RETVAL;
#line 68 "./xs/Repository.xs"
		Repository repo;

		int rc = git_repository_open(&repo, SvPVbyte_nolen(path));
		git_check_error(rc);

		RETVAL = sv_setref_pv(newSV(0), SvPVbyte_nolen(class), repo);

#line 2046 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Repository_discover); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Repository_discover)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "class, path");
    {
	SV *	class = ST(0)
;
	SV *	path = ST(1)
;
	SV *	RETVAL;
#line 83 "./xs/Repository.xs"
		Repository repo;
		char found[GIT_PATH_MAX];

		int rc = git_repository_discover(
			found, GIT_PATH_MAX, SvPVbyte_nolen(path), 1, NULL
		);
		git_check_error(rc);

		rc = git_repository_open(&repo, found);
		git_check_error(rc);

		RETVAL = sv_setref_pv(newSV(0), SvPVbyte_nolen(class), repo);

#line 2080 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Repository_config); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Repository_config)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Repository	self;
	Config	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Repository"))
		self = INT2PTR(Repository, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Repository")
;
#line 103 "./xs/Repository.xs"
		Config cfg;

		int rc = git_repository_config(&cfg, self);
		git_check_error(rc);

		RETVAL = cfg;

#line 2111 "Raw.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Git::Raw::Config", (void *) RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Repository_index); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Repository_index)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 117 "./xs/Repository.xs"
		Index index;

		int rc = git_repository_index(&index, GIT_SV_TO_PTR(Repository, self));
		git_check_error(rc);

		GIT_NEW_OBJ(RETVAL, "Git::Raw::Index", index, SvRV(self));

#line 2137 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Repository_head); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Repository_head)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 132 "./xs/Repository.xs"
		int rc;
		Reference head;
		Repository repo = GIT_SV_TO_PTR(Repository, self);

		if (items == 2) {
			Reference new_head = GIT_SV_TO_PTR(Reference, ST(1));

			rc = git_repository_set_head(
				repo, git_reference_name(new_head)
			);
			git_check_error(rc);
		}

		rc = git_repository_head(&head, repo);
		git_check_error(rc);

		RETVAL = sv_setref_pv(newSV(0), "Git::Raw::Reference", head);

		xs_object_magic_attach_struct(
			aTHX_ SvRV(RETVAL), SvREFCNT_inc_NN(SvRV(self))
		);

#line 2178 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Repository_lookup); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Repository_lookup)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, id");
    {
	SV *	self = ST(0)
;
	SV *	id = ST(1)
;
	SV *	RETVAL;
#line 162 "./xs/Repository.xs"
		git_oid oid;
		git_object *obj;

		STRLEN len;
		const char *id_str = SvPVbyte(id, len);

		int rc = git_oid_fromstrn(&oid, id_str, len);
		git_check_error(rc);

		rc = git_object_lookup_prefix(
			&obj, GIT_SV_TO_PTR(Repository, self), &oid, len, GIT_OBJ_ANY
		);
		git_check_error(rc);

		RETVAL = git_obj_to_sv(obj, self);

#line 2215 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Repository_checkout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Repository_checkout)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, target, opts");
    {
	Repository	self;
	SV *	target = ST(1)
;
	HV *	opts;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Repository"))
		self = INT2PTR(Repository, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Repository")
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(2);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    opts = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak(aTHX_ "%s: %s is not a HASH reference",
				"Git::Raw::Repository::checkout",
				"opts");
		}
	} STMT_END
;
#line 187 "./xs/Repository.xs"
		int rc;
		SV *strategy;

		git_checkout_opts checkout_opts = GIT_CHECKOUT_OPTS_INIT;

		strategy = *hv_fetchs(opts, "checkout_strategy", 0);
		checkout_opts.checkout_strategy =
			git_hv_to_checkout_strategy((HV *) SvRV(strategy));

		rc = git_checkout_tree(
			self, git_sv_to_obj(target), &checkout_opts
		);
		git_check_error(rc);
#line 2268 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Repository_reset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Repository_reset)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, target, type");
    {
	Repository	self;
	SV *	target = ST(1)
;
	SV *	type = ST(2)
;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Repository"))
		self = INT2PTR(Repository, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Repository")
;
#line 208 "./xs/Repository.xs"
		int rc;
		git_reset_t reset;

		STRLEN len;
		const char *type_str = SvPVbyte(type, len);

		if (strcmp(type_str, "soft"))
			reset = GIT_RESET_SOFT;
		else if (strcmp(type_str, "mixed"))
			reset = GIT_RESET_MIXED;
		else
			Perl_croak(aTHX_ "Invalid type");

		rc = git_reset(self, git_sv_to_obj(target), reset);
		git_check_error(rc);
#line 2308 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Repository_status); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Repository_status)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, path");
    {
	Repository	self;
	SV *	path = ST(1)
;
	AV *	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Repository"))
		self = INT2PTR(Repository, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Repository")
;
#line 230 "./xs/Repository.xs"
		unsigned iflags;

		AV *flags = newAV();

		int rc = git_status_file(&iflags, self, SvPVbyte_nolen(path));
		git_check_error(rc);

		if (iflags & GIT_STATUS_INDEX_NEW)
			av_push(flags, newSVpv("index_new", 0));

		if (iflags & GIT_STATUS_INDEX_MODIFIED)
			av_push(flags, newSVpv("index_modified", 0));

		if (iflags & GIT_STATUS_INDEX_DELETED)
			av_push(flags, newSVpv("index_deleted", 0));

		if (iflags & GIT_STATUS_WT_NEW)
			av_push(flags, newSVpv("worktree_new", 0));

		if (iflags & GIT_STATUS_WT_MODIFIED)
			av_push(flags, newSVpv("worktree_modified", 0));

		if (iflags & GIT_STATUS_WT_DELETED)
			av_push(flags, newSVpv("worktree_deleted", 0));

		if (iflags & GIT_STATUS_IGNORED)
			av_push(flags, newSVpv("ignored", 0));

		RETVAL = flags;

#line 2362 "Raw.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Repository_ignore); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Repository_ignore)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, rules");
    {
	Repository	self;
	SV *	rules = ST(1)
;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Repository"))
		self = INT2PTR(Repository, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Repository")
;
#line 268 "./xs/Repository.xs"
		int rc = git_ignore_add_rule(self, SvPVbyte_nolen(rules));
		git_check_error(rc);
#line 2389 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Repository_diff); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Repository_diff)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	Repository	self;
	Diff	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Repository"))
		self = INT2PTR(Repository, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Repository")
;
#line 277 "./xs/Repository.xs"
		int rc;

		Diff diff;
		Index index;

		rc = git_repository_index(&index, self);
		git_check_error(rc);

		switch (items) {
			case 1: {
				rc = git_diff_index_to_workdir(
					&diff, self, index, NULL
				);
				git_check_error(rc);

				break;
			}

			case 2: {
				Tree tree = GIT_SV_TO_PTR(Tree, ST(1));

				rc = git_diff_tree_to_index(
					&diff, self, tree, index, NULL
				);
				git_check_error(rc);

				break;
			}

			default: Perl_croak(aTHX_ "Wrong number of arguments");
		}

		RETVAL = diff;

#line 2445 "Raw.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Git::Raw::Diff", (void *) RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Repository_remotes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Repository_remotes)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Repository	self;
	AV *	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Repository"))
		self = INT2PTR(Repository, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Repository")
;
#line 318 "./xs/Repository.xs"
		int i;

		AV *output = newAV();
		git_strarray remotes;

		int rc = git_remote_list(&remotes, self);
		git_check_error(rc);

		for (i = 0; i < remotes.count; i++) {
			SV *sv;
			Remote remote;

			rc = git_remote_load(&remote, self, remotes.strings[i]);
			git_check_error(rc);

			sv = sv_setref_pv(newSV(0), "Git::Raw::Remote", remote);
			av_push(output, sv);
		}

		git_strarray_free(&remotes);

		RETVAL = output;

#line 2492 "Raw.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Repository_path); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Repository_path)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Repository	self;
	SV *	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Repository"))
		self = INT2PTR(Repository, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Repository")
;
#line 348 "./xs/Repository.xs"
		const char *path = git_repository_path(self);
		RETVAL = newSVpv(path, 0);

#line 2519 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Repository_workdir); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Repository_workdir)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	Repository	self;
	SV *	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Repository"))
		self = INT2PTR(Repository, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Repository")
;
#line 359 "./xs/Repository.xs"
		const char *path;

		if (items == 2) {
			const char *new_path = SvPVbyte_nolen(ST(1));

			int rc = git_repository_set_workdir(self, new_path, 1);
			git_check_error(rc);
		}

		path = git_repository_workdir(self);
		RETVAL = newSVpv(path, 0);

#line 2555 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Repository_is_bare); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Repository_is_bare)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Repository	self;
	bool	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Repository"))
		self = INT2PTR(Repository, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Repository")
;
#line 378 "./xs/Repository.xs"
		RETVAL = git_repository_is_bare(self);

#line 2581 "Raw.c"
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Repository_is_empty); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Repository_is_empty)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Repository	self;
	bool	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Repository"))
		self = INT2PTR(Repository, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Repository")
;
#line 387 "./xs/Repository.xs"
		RETVAL = git_repository_is_empty(self);

#line 2607 "Raw.c"
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Repository_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Repository_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Repository	self;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Repository"))
		self = INT2PTR(Repository, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Repository")
;
#line 396 "./xs/Repository.xs"
		git_repository_free(self);
#line 2631 "Raw.c"
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'xs/Remote.xs' from 'xs/Repository.xs' */


XS_EUPXS(XS_Git__Raw__Remote_create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Remote_create)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "class, repo, name, url");
    {
	SV *	class = ST(0)
;
	Repository	repo;
	SV *	name = ST(2)
;
	SV *	url = ST(3)
;
	Remote	RETVAL;

	if (sv_isobject(ST(1)) && sv_derived_from(ST(1), "Git::Raw::Repository"))
		repo = INT2PTR(Repository, SvIV((SV *) SvRV(ST(1))));
	else
		Perl_croak(aTHX_ "repo is not of type Git::Raw::Repository")
;
#line 11 "./xs/Remote.xs"
		Remote remote;

		int rc = git_remote_create(
			&remote, repo, SvPVbyte_nolen(name), SvPVbyte_nolen(url)
		);
		git_check_error(rc);

		RETVAL = remote;

#line 2671 "Raw.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Git::Raw::Remote", (void *) RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Remote_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Remote_name)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	Remote	self;
	SV *	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Remote"))
		self = INT2PTR(Remote, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Remote")
;
#line 28 "./xs/Remote.xs"
		const char *name;

		if (items == 2) {
			int rc = git_remote_rename(
				self, SvPVbyte_nolen(ST(1)), NULL, NULL
			);
			git_check_error(rc);
		}

		name = git_remote_name(self);

		RETVAL = newSVpv(name, 0);

#line 2708 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Remote_url); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Remote_url)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	Remote	self;
	SV *	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Remote"))
		self = INT2PTR(Remote, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Remote")
;
#line 49 "./xs/Remote.xs"
		const char *url;

		if (items == 2) {
			int rc = git_remote_set_url(self, SvPVbyte_nolen(ST(1)));
			git_check_error(rc);
		}

		url = git_remote_url(self);

		RETVAL = newSVpv(url, 0);

#line 2743 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Remote_add_fetch); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Remote_add_fetch)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, spec");
    {
	Remote	self;
	RefSpec	spec;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Remote"))
		self = INT2PTR(Remote, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Remote")
;

	if (sv_isobject(ST(1)) && sv_derived_from(ST(1), "Git::Raw::RefSpec"))
		spec = INT2PTR(RefSpec, SvIV((SV *) SvRV(ST(1))));
	else
		Perl_croak(aTHX_ "spec is not of type Git::Raw::RefSpec")
;
#line 68 "./xs/Remote.xs"
		int rc = git_remote_add_fetch(self, SvPVbyte_nolen(ST(1)));
		git_check_error(rc);
#line 2775 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Remote_add_push); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Remote_add_push)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	Remote	self;
	RefSpec;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Remote"))
		self = INT2PTR(Remote, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Remote")
;
#line 77 "./xs/Remote.xs"
		int rc = git_remote_add_push(self, SvPVbyte_nolen(ST(1)));
		git_check_error(rc);
#line 2799 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Remote_connect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Remote_connect)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, direction");
    {
	Remote	self;
	SV *	direction = ST(1)
;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Remote"))
		self = INT2PTR(Remote, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Remote")
;
#line 86 "./xs/Remote.xs"
		git_direction direct;
		const char *dir = SvPVbyte_nolen(direction);

		if (strcmp(dir, "fetch") == 0)
			direct = GIT_DIRECTION_FETCH;
		else if (strcmp(dir, "push") == 0)
			direct = GIT_DIRECTION_PUSH;
		else
			Perl_croak(aTHX_ "Invalid direction");

		int rc = git_remote_connect(self, direct);
		git_check_error(rc);
#line 2834 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Remote_disconnect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Remote_disconnect)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Remote	self;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Remote"))
		self = INT2PTR(Remote, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Remote")
;
#line 104 "./xs/Remote.xs"
		git_remote_disconnect(self);
#line 2856 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Remote_download); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Remote_download)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Remote	self;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Remote"))
		self = INT2PTR(Remote, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Remote")
;
#line 111 "./xs/Remote.xs"
		int rc = git_remote_download(self, NULL, NULL);
		git_check_error(rc);
#line 2879 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Remote_save); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Remote_save)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Remote	self;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Remote"))
		self = INT2PTR(Remote, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Remote")
;
#line 119 "./xs/Remote.xs"
		int rc = git_remote_save(self);
		git_check_error(rc);
#line 2902 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Remote_update_tips); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Remote_update_tips)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Remote	self;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Remote"))
		self = INT2PTR(Remote, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Remote")
;
#line 127 "./xs/Remote.xs"
		int rc = git_remote_update_tips(self);
		git_check_error(rc);
#line 2925 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Remote_cred_acquire); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Remote_cred_acquire)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, cb");
    {
	Remote	self;
	SV *	cb = ST(1)
;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Remote"))
		self = INT2PTR(Remote, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Remote")
;
#line 136 "./xs/Remote.xs"
		SvREFCNT_inc(cb);
		git_remote_set_cred_acquire_cb(self, git_cred_acquire_cbb, cb);
#line 2950 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Remote_is_connected); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Remote_is_connected)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Remote	self;
	bool	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Remote"))
		self = INT2PTR(Remote, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Remote")
;
#line 144 "./xs/Remote.xs"
		RETVAL = git_remote_connected(self);

#line 2974 "Raw.c"
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Remote_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Remote_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Remote	self;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Remote"))
		self = INT2PTR(Remote, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Remote")
;
#line 153 "./xs/Remote.xs"
		git_remote_free(self);
#line 2998 "Raw.c"
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'xs/RefSpec.xs' from 'xs/Remote.xs' */


XS_EUPXS(XS_Git__Raw__RefSpec_dst); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__RefSpec_dst)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	RefSpec	self;
	SV *	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::RefSpec"))
		self = INT2PTR(RefSpec, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::RefSpec")
;
#line 8 "./xs/RefSpec.xs"
		RETVAL = newSVpv(git_refspec_dst(self), 0);

#line 3025 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__RefSpec_src); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__RefSpec_src)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	RefSpec	self;
	SV *	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::RefSpec"))
		self = INT2PTR(RefSpec, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::RefSpec")
;
#line 17 "./xs/RefSpec.xs"
		RETVAL = newSVpv(git_refspec_src(self), 0);

#line 3051 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'xs/Reference.xs' from 'xs/RefSpec.xs' */


XS_EUPXS(XS_Git__Raw__Reference_lookup); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Reference_lookup)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "class, name, repo");
    {
	SV *	class = ST(0)
;
	SV *	name = ST(1)
;
	SV *	repo = ST(2)
;
	SV *	RETVAL;
#line 10 "./xs/Reference.xs"
		Reference ref;

		int rc = git_reference_lookup(
			&ref, GIT_SV_TO_PTR(Repository, repo),
			SvPVbyte_nolen(name)
		);
		git_check_error(rc);

		GIT_NEW_OBJ(RETVAL, SvPVbyte_nolen(class), ref, SvRV(repo));

#line 3087 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Reference_delete); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Reference_delete)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 27 "./xs/Reference.xs"
		int rc;
		Reference ref = GIT_SV_TO_PTR(Reference, self);

		rc = git_reference_delete(ref);
		git_check_error(rc);

		sv_setiv(SvRV(self), 0);
#line 3112 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Reference_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Reference_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Reference	self;
	SV *	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Reference"))
		self = INT2PTR(Reference, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Reference")
;
#line 40 "./xs/Reference.xs"
		const char *msg = git_reference_name(self);
		RETVAL = newSVpv(msg, 0);

#line 3137 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Reference_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Reference_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Reference	self;
	SV *	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Reference"))
		self = INT2PTR(Reference, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Reference")
;
#line 50 "./xs/Reference.xs"
		SV *type;

		switch (git_reference_type(self)) {
			case GIT_REF_OID: type = newSVpv("direct", 0); break;
			case GIT_REF_SYMBOLIC: type = newSVpv("symbolic", 0); break;
			default: Perl_croak(aTHX_ "Invalid reference type");
		}

		RETVAL = type;

#line 3171 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Reference_owner); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Reference_owner)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 67 "./xs/Reference.xs"
		if (!SvROK(self)) Perl_croak(aTHX_ "Not a reference");

		SV *r = xs_object_magic_get_struct(aTHX_ SvRV(self));
		if (!r) Perl_croak(aTHX_ "Invalid object");

		RETVAL = newRV_inc(r);

#line 3197 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Reference_target); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Reference_target)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 82 "./xs/Reference.xs"
		int rc;
		Reference ref = GIT_SV_TO_PTR(Reference, self);

		switch (git_reference_type(ref)) {
			case GIT_REF_OID: {
				git_object *obj;
				const git_oid *oid;

				oid = git_reference_target(ref);

				rc = git_object_lookup(
					&obj, git_reference_owner(ref),
					oid, GIT_OBJ_ANY
				);
				git_check_error(rc);

				RETVAL = git_obj_to_sv(obj, self);
				break;
			}

			case GIT_REF_SYMBOLIC: {
				Reference ref;
				const char *target;
				SV *repo = GIT_SV_TO_REPO(self);

				target = git_reference_symbolic_target(ref);

				rc = git_reference_lookup(&ref, git_reference_owner(ref), target);
				git_check_error(rc);

				GIT_NEW_OBJ(
					RETVAL, "Git::Raw::Reference", ref, repo
				);
				break;
			}

			default: Perl_croak(aTHX_ "Invalid reference type");
		}

#line 3255 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Reference_is_branch); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Reference_is_branch)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Reference	self;
	bool	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Reference"))
		self = INT2PTR(Reference, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Reference")
;
#line 128 "./xs/Reference.xs"
		RETVAL = git_reference_is_branch(self);

#line 3281 "Raw.c"
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Reference_is_remote); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Reference_is_remote)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Reference	self;
	bool	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Reference"))
		self = INT2PTR(Reference, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Reference")
;
#line 137 "./xs/Reference.xs"
		RETVAL = git_reference_is_remote(self);

#line 3307 "Raw.c"
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Reference_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Reference_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 146 "./xs/Reference.xs"
		git_reference_free(GIT_SV_TO_PTR(Reference, self));
		SvREFCNT_dec(xs_object_magic_get_struct(aTHX_ SvRV(self)));
#line 3327 "Raw.c"
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'xs/Push.xs' from 'xs/Reference.xs' */


XS_EUPXS(XS_Git__Raw__Push_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Push_new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "class, remote");
    {
	SV *	class = ST(0)
;
	Remote	remote;
	Push	RETVAL;

	if (sv_isobject(ST(1)) && sv_derived_from(ST(1), "Git::Raw::Remote"))
		remote = INT2PTR(Remote, SvIV((SV *) SvRV(ST(1))));
	else
		Perl_croak(aTHX_ "remote is not of type Git::Raw::Remote")
;
#line 9 "./xs/Push.xs"
		Push push;

		int rc = git_push_new(&push, remote);
		git_check_error(rc);

		RETVAL = push;

#line 3361 "Raw.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Git::Raw::Push", (void *) RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Push_add_refspec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Push_add_refspec)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, refspec");
    {
	Push	self;
	SV *	refspec = ST(1)
;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Push"))
		self = INT2PTR(Push, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Push")
;
#line 24 "./xs/Push.xs"
		int rc = git_push_add_refspec(self, SvPVbyte_nolen(refspec));
		git_check_error(rc);
#line 3388 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Push_finish); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Push_finish)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Push	self;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Push"))
		self = INT2PTR(Push, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Push")
;
#line 32 "./xs/Push.xs"
		int rc = git_push_finish(self);
		git_check_error(rc);
#line 3411 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Push_unpack_ok); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Push_unpack_ok)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Push	self;
	bool	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Push"))
		self = INT2PTR(Push, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Push")
;
#line 40 "./xs/Push.xs"
		RETVAL = git_push_unpack_ok(self);

#line 3435 "Raw.c"
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Push_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Push_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Push	self;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Push"))
		self = INT2PTR(Push, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Push")
;
#line 49 "./xs/Push.xs"
		git_push_free(self);
#line 3459 "Raw.c"
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'xs/Index.xs' from 'xs/Push.xs' */


XS_EUPXS(XS_Git__Raw__Index_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Index_add)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, path");
    {
	Index	self;
	SV *	path = ST(1)
;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Index"))
		self = INT2PTR(Index, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Index")
;
#line 9 "./xs/Index.xs"
		int rc = git_index_add_bypath(self, SvPVbyte_nolen(path));
		git_check_error(rc);
#line 3487 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Index_clear); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Index_clear)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Index	self;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Index"))
		self = INT2PTR(Index, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Index")
;
#line 17 "./xs/Index.xs"
		git_index_clear(self);
#line 3509 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Index_read); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Index_read)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Index	self;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Index"))
		self = INT2PTR(Index, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Index")
;
#line 24 "./xs/Index.xs"
		int rc = git_index_read(self);
		git_check_error(rc);
#line 3532 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Index_write); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Index_write)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Index	self;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Index"))
		self = INT2PTR(Index, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Index")
;
#line 32 "./xs/Index.xs"
		int rc = git_index_write(self);
		git_check_error(rc);
#line 3555 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Index_read_tree); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Index_read_tree)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, tree");
    {
	Index	self;
	Tree	tree;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Index"))
		self = INT2PTR(Index, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Index")
;

	if (sv_isobject(ST(1)) && sv_derived_from(ST(1), "Git::Raw::Tree"))
		tree = INT2PTR(Tree, SvIV((SV *) SvRV(ST(1))));
	else
		Perl_croak(aTHX_ "tree is not of type Git::Raw::Tree")
;
#line 41 "./xs/Index.xs"
		int rc = git_index_read_tree(self, tree);
		git_check_error(rc);
#line 3585 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Index_write_tree); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Index_write_tree)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Index	self;
	SV *	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Index"))
		self = INT2PTR(Index, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Index")
;
#line 49 "./xs/Index.xs"
		git_oid oid;

		int rc = git_index_write_tree(&oid, self);
		git_check_error(rc);

		RETVAL = git_oid_to_sv(&oid);

#line 3614 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Index_remove); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Index_remove)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, path");
    {
	Index	self;
	SV *	path = ST(1)
;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Index"))
		self = INT2PTR(Index, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Index")
;
#line 64 "./xs/Index.xs"
		int rc = git_index_remove(self, SvPVbyte_nolen(path), 0);
		git_check_error(rc);
#line 3641 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Index_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Index_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV*	self = ST(0)
;
#line 72 "./xs/Index.xs"
		git_index_free(GIT_SV_TO_PTR(Index, self));
		SvREFCNT_dec(xs_object_magic_get_struct(aTHX_ SvRV(self)));
#line 3659 "Raw.c"
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'xs/Diff.xs' from 'xs/Index.xs' */


XS_EUPXS(XS_Git__Raw__Diff_merge); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Diff_merge)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, from");
    {
	Diff	self;
	Diff	from;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Diff"))
		self = INT2PTR(Diff, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Diff")
;

	if (sv_isobject(ST(1)) && sv_derived_from(ST(1), "Git::Raw::Diff"))
		from = INT2PTR(Diff, SvIV((SV *) SvRV(ST(1))));
	else
		Perl_croak(aTHX_ "from is not of type Git::Raw::Diff")
;
#line 9 "./xs/Diff.xs"
		int rc = git_diff_merge(self, from);
		git_check_error(rc);
#line 3692 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Diff_patch); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Diff_patch)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, callback");
    {
	Diff	self;
	SV *	callback = ST(1)
;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Diff"))
		self = INT2PTR(Diff, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Diff")
;
#line 18 "./xs/Diff.xs"
		int rc = git_diff_print_patch(self, git_diff_cb, callback);
		git_check_error(rc);
#line 3717 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Diff_compact); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Diff_compact)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, callback");
    {
	Diff	self;
	SV *	callback = ST(1)
;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Diff"))
		self = INT2PTR(Diff, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Diff")
;
#line 27 "./xs/Diff.xs"
		int rc = git_diff_print_compact(self, git_diff_cb, callback);
		git_check_error(rc);
#line 3742 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Diff_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Diff_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Diff	self;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Diff"))
		self = INT2PTR(Diff, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Diff")
;
#line 35 "./xs/Diff.xs"
		git_diff_list_free(self);
#line 3764 "Raw.c"
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'xs/Cred.xs' from 'xs/Diff.xs' */


XS_EUPXS(XS_Git__Raw__Cred_plaintext); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Cred_plaintext)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "class, user, pass");
    {
	SV *	class = ST(0)
;
	SV *	user = ST(1)
;
	SV *	pass = ST(2)
;
	Cred	RETVAL;
#line 10 "./xs/Cred.xs"
		Cred out;

		const char *usr = SvPVbyte_nolen(user);
		const char *pwd = SvPVbyte_nolen(pass);

		int rc = git_cred_userpass_plaintext_new(&out, usr, pwd);
		git_check_error(rc);

		RETVAL = out;

#line 3798 "Raw.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Git::Raw::Cred", (void *) RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Cred_keyfile); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Cred_keyfile)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "class, public, private, pass");
    {
	SV *	class = ST(0)
;
	SV *	public = ST(1)
;
	SV *	private = ST(2)
;
	SV *	pass = ST(3)
;
	Cred	RETVAL;
#line 30 "./xs/Cred.xs"
#ifdef GIT_SSH
		Cred out;

		const char *publickey  = SvPVbyte_nolen(public);
		const char *privatekey = SvPVbyte_nolen(private);
		const char *passphrase = SvPVbyte_nolen(private);

		int rc = git_cred_ssh_keyfile_passphrase_new(
			&out, publickey, privatekey, passphrase
		);
		git_check_error(rc);

		RETVAL = out;
#else
		RETVAL = &PL_sv_undef;
#endif

#line 3840 "Raw.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Git::Raw::Cred", (void *) RETVAL);
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'xs/Config.xs' from 'xs/Cred.xs' */


XS_EUPXS(XS_Git__Raw__Config_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Config_new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "class");
    {
	SV *	class = ST(0)
;
	SV *	RETVAL;
#line 8 "./xs/Config.xs"
		Config cfg;

		int rc = git_config_new(&cfg);
		git_check_error(rc);

		RETVAL = sv_setref_pv(newSV(0), SvPVbyte_nolen(class), cfg);

#line 3869 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Config_add_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Config_add_file)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, path, level");
    {
	Config	self;
	SV *	path = ST(1)
;
	int	level = (int)SvIV(ST(2))
;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Config"))
		self = INT2PTR(Config, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Config")
;
#line 24 "./xs/Config.xs"
		int rc = git_config_add_file_ondisk(
			self, SvPVbyte_nolen(path), level, 0
		);
		git_check_error(rc);
#line 3900 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Config_bool); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Config_bool)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "self, name, ...");
    {
	Config	self;
	SV *	name = ST(1)
;
	SV *	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Config"))
		self = INT2PTR(Config, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Config")
;
#line 36 "./xs/Config.xs"
		int rc, value;
		const char *var = SvPVbyte_nolen(name);

		switch (items) {
			case 2: {
				rc = git_config_get_bool(&value, self, var);

				if (rc != GIT_ENOTFOUND)
					git_check_error(rc);

				break;
			}

			case 3: {
				value = SvIV(ST(2));

				rc = git_config_set_bool(self, var, value);
				git_check_error(rc);

				break;
			}
		}

		RETVAL = (rc != GIT_ENOTFOUND) ? boolSV(value) : &PL_sv_undef;

#line 3949 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Config_int); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Config_int)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "self, name, ...");
    {
	Config	self;
	SV *	name = ST(1)
;
	SV *	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Config"))
		self = INT2PTR(Config, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Config")
;
#line 70 "./xs/Config.xs"
		int rc, value;
		const char *var = SvPVbyte_nolen(name);

		switch (items) {
			case 2: {
				rc = git_config_get_int32(&value, self, var);

				if (rc != GIT_ENOTFOUND)
					git_check_error(rc);

				break;
			}

			case 3: {
				value = SvIV(ST(2));

				rc = git_config_set_int32(self, var, value);
				git_check_error(rc);

				break;
			}
		}

		RETVAL = (rc != GIT_ENOTFOUND) ? newSViv(value) : &PL_sv_undef;

#line 4000 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Config_str); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Config_str)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "self, name, ...");
    {
	Config	self;
	SV *	name = ST(1)
;
	SV *	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Config"))
		self = INT2PTR(Config, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Config")
;
#line 104 "./xs/Config.xs"
		int rc;
		const char *value, *var = SvPVbyte_nolen(name);

		switch (items) {
			case 2: {
				rc = git_config_get_string(&value, self, var);

				if (rc != GIT_ENOTFOUND)
					git_check_error(rc);

				break;
			}

			case 3: {
				value = SvPVbyte_nolen(ST(2));

				rc = git_config_set_string(self, var, value);
				git_check_error(rc);

				break;
			}
		}

		RETVAL = (rc != GIT_ENOTFOUND) ? newSVpv(value, 0) : &PL_sv_undef;

#line 4051 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Config_foreach); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Config_foreach)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, cb");
    {
	Config	self;
	SV *	cb = ST(1)
;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Config"))
		self = INT2PTR(Config, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Config")
;
#line 137 "./xs/Config.xs"
		git_foreach_payload payload = {
			.repo = NULL,
			.cb = cb
		};

		int rc = git_config_foreach(
			self, git_config_foreach_cbb, &payload
		);

		if (rc != GIT_EUSER)
			git_check_error(rc);
#line 4087 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Config_refresh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Config_refresh)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Config	self;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Config"))
		self = INT2PTR(Config, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Config")
;
#line 154 "./xs/Config.xs"
		int rc = git_config_refresh(self);
		git_check_error(rc);
#line 4110 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Config_delete); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Config_delete)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, name");
    {
	Config	self;
	SV *	name = ST(1)
;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Config"))
		self = INT2PTR(Config, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Config")
;
#line 163 "./xs/Config.xs"
		int rc = git_config_delete_entry(self, SvPVbyte_nolen(name));
		git_check_error(rc);
#line 4135 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Config_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Config_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Config	self;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Config"))
		self = INT2PTR(Config, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Config")
;
#line 171 "./xs/Config.xs"
		git_config_free(self);
#line 4157 "Raw.c"
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'xs/Commit.xs' from 'xs/Config.xs' */


XS_EUPXS(XS_Git__Raw__Commit_create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Commit_create)
{
    dVAR; dXSARGS;
    if (items != 7)
       croak_xs_usage(cv,  "class, repo, msg, author, committer, parents, tree");
    {
	SV *	class = ST(0)
;
	SV *	repo = ST(1)
;
	SV *	msg = ST(2)
;
	Signature	author;
	Signature	committer;
	AV *	parents;
	Tree	tree;
	SV *	RETVAL;

	if (sv_isobject(ST(3)) && sv_derived_from(ST(3), "Git::Raw::Signature"))
		author = INT2PTR(Signature, SvIV((SV *) SvRV(ST(3))));
	else
		Perl_croak(aTHX_ "author is not of type Git::Raw::Signature")
;

	if (sv_isobject(ST(4)) && sv_derived_from(ST(4), "Git::Raw::Signature"))
		committer = INT2PTR(Signature, SvIV((SV *) SvRV(ST(4))));
	else
		Perl_croak(aTHX_ "committer is not of type Git::Raw::Signature")
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(5);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    parents = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak(aTHX_ "%s: %s is not an ARRAY reference",
				"Git::Raw::Commit::create",
				"parents");
		}
	} STMT_END
;

	if (sv_isobject(ST(6)) && sv_derived_from(ST(6), "Git::Raw::Tree"))
		tree = INT2PTR(Tree, SvIV((SV *) SvRV(ST(6))));
	else
		Perl_croak(aTHX_ "tree is not of type Git::Raw::Tree")
;
#line 14 "./xs/Commit.xs"
		git_oid oid;
		Commit commit, *commit_parents = NULL;

		int count = av_len(parents) + 1;

		if (count > 0) {
			int i; SV *iter;

			Newx(commit_parents, count, git_commit *);

			for (i = 0; i < count; i++) {
				iter = av_shift(parents);

				commit_parents[i] = GIT_SV_TO_PTR(Commit, iter);
			}
		}

		int rc = git_commit_create(
			&oid, GIT_SV_TO_PTR(Repository, repo), "HEAD", author, committer, NULL,
			SvPVbyte_nolen(msg), tree, count,
			(const git_commit **) commit_parents
		);
		git_check_error(rc);

		rc = git_commit_lookup(&commit, GIT_SV_TO_PTR(Repository, repo), &oid);
		git_check_error(rc);

		GIT_NEW_OBJ(RETVAL, SvPVbyte_nolen(class), commit, SvRV(repo));

#line 4246 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Commit_lookup); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Commit_lookup)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "class, repo, id");
    {
	SV *	class = ST(0)
;
	SV *	repo = ST(1)
;
	SV *	id = ST(2)
;
	SV *	RETVAL;
#line 52 "./xs/Commit.xs"
		git_oid oid;
		Commit commit;
		Repository repo_ptr = GIT_SV_TO_PTR(Repository, repo);

		STRLEN len;
		const char *id_str = SvPVbyte(id, len);

		int rc = git_oid_fromstrn(&oid, id_str, len);
		git_check_error(rc);

		rc = git_commit_lookup_prefix(&commit, repo_ptr, &oid, len);
		git_check_error(rc);

		GIT_NEW_OBJ(RETVAL, SvPVbyte_nolen(class), commit, SvRV(repo));

#line 4284 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Commit_id); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Commit_id)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Commit	self;
	SV *	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Commit"))
		self = INT2PTR(Commit, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Commit")
;
#line 74 "./xs/Commit.xs"
		const git_oid *oid = git_commit_id(self);
		RETVAL = git_oid_to_sv((git_oid *) oid);

#line 4311 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Commit_message); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Commit_message)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Commit	self;
	SV *	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Commit"))
		self = INT2PTR(Commit, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Commit")
;
#line 84 "./xs/Commit.xs"
		const char *msg = git_commit_message(self);
		RETVAL = newSVpv(msg, 0);

#line 4338 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Commit_author); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Commit_author)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Commit	self;
	Signature	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Commit"))
		self = INT2PTR(Commit, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Commit")
;
#line 94 "./xs/Commit.xs"
		Signature a = (Signature) git_commit_author(self);
		RETVAL = git_signature_dup(a);

#line 4365 "Raw.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Git::Raw::Signature", (void *) RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Commit_committer); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Commit_committer)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Commit	self;
	Signature	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Commit"))
		self = INT2PTR(Commit, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Commit")
;
#line 104 "./xs/Commit.xs"
		Signature c = (Signature) git_commit_committer(self);
		RETVAL = git_signature_dup(c);

#line 4392 "Raw.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Git::Raw::Signature", (void *) RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Commit_time); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Commit_time)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Commit	self;
	SV *	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Commit"))
		self = INT2PTR(Commit, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Commit")
;
#line 114 "./xs/Commit.xs"
		git_time_t time = git_commit_time(self);

		const int n = snprintf(NULL, 0, "%" PRId64, time);
		char buf[n+1];

		snprintf(buf, n+1, "%" PRId64, time);

		RETVAL = newSVpv(buf, 0);

#line 4425 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Commit_offset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Commit_offset)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Commit	self;
	int	RETVAL;
	dXSTARG;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Commit"))
		self = INT2PTR(Commit, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Commit")
;
#line 130 "./xs/Commit.xs"
		RETVAL = git_commit_time_offset(self);

#line 4452 "Raw.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Commit_tree); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Commit_tree)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 139 "./xs/Commit.xs"
		Tree tree;
		SV *repo = GIT_SV_TO_REPO(self);

		int rc = git_commit_tree(&tree, GIT_SV_TO_PTR(Commit, self));
		git_check_error(rc);

		GIT_NEW_OBJ(RETVAL, "Git::Raw::Tree", tree, repo);

#line 4478 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Commit_parents); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Commit_parents)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	AV *	RETVAL;
#line 154 "./xs/Commit.xs"
		SV *repo = GIT_SV_TO_REPO(self);

		AV *parents = newAV();
		Commit child = GIT_SV_TO_PTR(Commit, self);
		int rc, i, count = git_commit_parentcount(child);

		for (i = 0; i < count; i++) {
			SV *tmp;
			Commit parent;

			rc = git_commit_parent(&parent, child, i);
			git_check_error(rc);

			GIT_NEW_OBJ(tmp, "Git::Raw::Commit", parent, repo);
			av_push(parents, tmp);
		}

		RETVAL = parents;

#line 4516 "Raw.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Commit_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Commit_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 180 "./xs/Commit.xs"
		git_commit_free(GIT_SV_TO_PTR(Commit, self));
		SvREFCNT_dec(xs_object_magic_get_struct(aTHX_ SvRV(self)));
#line 4536 "Raw.c"
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'xs/Branch.xs' from 'xs/Commit.xs' */


XS_EUPXS(XS_Git__Raw__Branch_create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Branch_create)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "class, repo, name, target");
    {
	SV *	class = ST(0)
;
	SV *	repo = ST(1)
;
	SV *	name = ST(2)
;
	SV *	target = ST(3)
;
	SV *	RETVAL;
#line 17 "./xs/Branch.xs"
		Reference ref;
		Commit obj = (Commit) git_sv_to_obj(target);

		int rc = git_branch_create(
			&ref, GIT_SV_TO_PTR(Repository, repo),
			SvPVbyte_nolen(name), obj, 0
		);
		git_check_error(rc);

		GIT_NEW_OBJ(RETVAL, SvPVbyte_nolen(class), ref, SvRV(repo));

#line 4573 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Branch_lookup); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Branch_lookup)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "class, repo, name, is_local");
    {
	SV *	class = ST(0)
;
	SV *	repo = ST(1)
;
	SV *	name = ST(2)
;
	bool	is_local = (bool)SvTRUE(ST(3))
;
	SV *	RETVAL;
#line 38 "./xs/Branch.xs"
		Reference branch;

		git_branch_t type = is_local ?
			GIT_BRANCH_LOCAL     :
			GIT_BRANCH_REMOTE    ;

		int rc = git_branch_lookup(
			&branch, GIT_SV_TO_PTR(Repository, repo),
			SvPVbyte_nolen(name), type
		);
		git_check_error(rc);

		GIT_NEW_OBJ(RETVAL, SvPVbyte_nolen(class), branch, SvRV(repo));

#line 4612 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Branch_move); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Branch_move)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, name, force");
    {
	SV *	self = ST(0)
;
	SV *	name = ST(1)
;
	bool	force = (bool)SvTRUE(ST(2))
;
#line 61 "./xs/Branch.xs"
		Branch old_branch = GIT_SV_TO_PTR(Branch, self),
		       new_branch;

		int rc = git_branch_move(
			&new_branch, old_branch, SvPVbyte_nolen(name), force
		);
		git_check_error(rc);
#line 4641 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Branch_foreach); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Branch_foreach)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "class, repo, cb");
    {
	SV *	class = ST(0)
;
	SV *	repo = ST(1)
;
	SV *	cb = ST(2)
;
#line 76 "./xs/Branch.xs"
		git_foreach_payload payload = {
			.repo     = repo,
			.repo_ptr = GIT_SV_TO_PTR(Repository, repo),
			.cb       = cb,
			.class    = SvPVbyte_nolen(class)
		};

		int rc = git_branch_foreach(
			payload.repo_ptr, GIT_BRANCH_LOCAL | GIT_BRANCH_REMOTE,
			git_branch_foreach_cbb, &payload
		);

		if (rc != GIT_EUSER)
			git_check_error(rc);
#line 4675 "Raw.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Git__Raw__Branch_upstream); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Branch_upstream)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Branch	self;
	Reference	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Branch"))
		self = INT2PTR(Branch, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Branch")
;
#line 96 "./xs/Branch.xs"
		Reference ref;

		int rc = git_branch_upstream(&ref, self);
		git_check_error(rc);

		RETVAL = ref;

#line 4704 "Raw.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Git::Raw::Reference", (void *) RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Branch_is_head); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Branch_is_head)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Branch	self;
	bool	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Branch"))
		self = INT2PTR(Branch, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Branch")
;
#line 110 "./xs/Branch.xs"
		RETVAL = git_branch_is_head(self);

#line 4730 "Raw.c"
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'xs/Blob.xs' from 'xs/Branch.xs' */


XS_EUPXS(XS_Git__Raw__Blob_create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Blob_create)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "class, repo, buffer");
    {
	SV *	class = ST(0)
;
	SV *	repo = ST(1)
;
	SV *	buffer = ST(2)
;
	SV *	RETVAL;
#line 10 "./xs/Blob.xs"
		Blob blob;
		git_oid oid;

		STRLEN len;
		const char *buffer_str = SvPVbyte(buffer, len);
		Repository repo_ptr = GIT_SV_TO_PTR(Repository, repo);

		int rc = git_blob_create_frombuffer(&oid, repo_ptr, buffer_str, len);
		git_check_error(rc);

		rc = git_blob_lookup(&blob, repo_ptr, &oid);
		git_check_error(rc);

		GIT_NEW_OBJ(RETVAL, SvPVbyte_nolen(class), blob, SvRV(repo));

#line 4771 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Blob_lookup); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Blob_lookup)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "class, repo, id");
    {
	SV *	class = ST(0)
;
	SV *	repo = ST(1)
;
	SV *	id = ST(2)
;
	SV *	RETVAL;
#line 34 "./xs/Blob.xs"
		Blob blob;
		git_oid oid;
		Repository repo_ptr = GIT_SV_TO_PTR(Repository, repo);

		STRLEN len;
		const char *id_str = SvPVbyte(id, len);

		int rc = git_oid_fromstrn(&oid, id_str, len);
		git_check_error(rc);

		rc = git_blob_lookup_prefix(&blob, repo_ptr, &oid, len);
		git_check_error(rc);

		GIT_NEW_OBJ(RETVAL, SvPVbyte_nolen(class), blob, SvRV(repo));

#line 4809 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Blob_content); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Blob_content)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Blob	self;
	SV *	RETVAL;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Blob"))
		self = INT2PTR(Blob, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Blob")
;
#line 56 "./xs/Blob.xs"
		size_t len = git_blob_rawsize(self);
		RETVAL = newSVpv(git_blob_rawcontent(self), len);

#line 4836 "Raw.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Blob_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Blob_size)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Blob	self;
	size_t	RETVAL;
	dXSTARG;

	if (sv_isobject(ST(0)) && sv_derived_from(ST(0), "Git::Raw::Blob"))
		self = INT2PTR(Blob, SvIV((SV *) SvRV(ST(0))));
	else
		Perl_croak(aTHX_ "self is not of type Git::Raw::Blob")
;
#line 66 "./xs/Blob.xs"
		size_t len = git_blob_rawsize(self);
		RETVAL = len;

#line 4864 "Raw.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Git__Raw__Blob_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Git__Raw__Blob_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 76 "./xs/Blob.xs"
		git_blob_free(GIT_SV_TO_PTR(Blob, self));
		SvREFCNT_dec(xs_object_magic_get_struct(aTHX_ SvRV(self)));
#line 4883 "Raw.c"
    }
    XSRETURN_EMPTY;
}


/* INCLUDE: Returning to 'Raw.xs' from 'xs/Blob.xs' */

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Git__Raw); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Git__Raw)
{
    dVAR; dXSARGS;
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#endif
    XS_VERSION_BOOTCHECK;

        newXS("Git::Raw::Walker::create", XS_Git__Raw__Walker_create, file);
        newXS("Git::Raw::Walker::push", XS_Git__Raw__Walker_push, file);
        newXS("Git::Raw::Walker::push_glob", XS_Git__Raw__Walker_push_glob, file);
        newXS("Git::Raw::Walker::push_ref", XS_Git__Raw__Walker_push_ref, file);
        newXS("Git::Raw::Walker::push_head", XS_Git__Raw__Walker_push_head, file);
        newXS("Git::Raw::Walker::hide", XS_Git__Raw__Walker_hide, file);
        newXS("Git::Raw::Walker::hide_glob", XS_Git__Raw__Walker_hide_glob, file);
        newXS("Git::Raw::Walker::hide_ref", XS_Git__Raw__Walker_hide_ref, file);
        newXS("Git::Raw::Walker::hide_head", XS_Git__Raw__Walker_hide_head, file);
        newXS("Git::Raw::Walker::next", XS_Git__Raw__Walker_next, file);
        newXS("Git::Raw::Walker::reset", XS_Git__Raw__Walker_reset, file);
        newXS("Git::Raw::Walker::DESTROY", XS_Git__Raw__Walker_DESTROY, file);
        newXS("Git::Raw::TreeEntry::id", XS_Git__Raw__TreeEntry_id, file);
        newXS("Git::Raw::TreeEntry::name", XS_Git__Raw__TreeEntry_name, file);
        newXS("Git::Raw::TreeEntry::object", XS_Git__Raw__TreeEntry_object, file);
        newXS("Git::Raw::TreeEntry::DESTROY", XS_Git__Raw__TreeEntry_DESTROY, file);
        newXS("Git::Raw::Tree::lookup", XS_Git__Raw__Tree_lookup, file);
        newXS("Git::Raw::Tree::id", XS_Git__Raw__Tree_id, file);
        newXS("Git::Raw::Tree::entries", XS_Git__Raw__Tree_entries, file);
        newXS("Git::Raw::Tree::entry_byname", XS_Git__Raw__Tree_entry_byname, file);
        newXS("Git::Raw::Tree::entry_bypath", XS_Git__Raw__Tree_entry_bypath, file);
        (void)newXSproto_portable("Git::Raw::Tree::diff", XS_Git__Raw__Tree_diff, file, "$;$");
        newXS("Git::Raw::Tree::DESTROY", XS_Git__Raw__Tree_DESTROY, file);
        newXS("Git::Raw::Tag::create", XS_Git__Raw__Tag_create, file);
        newXS("Git::Raw::Tag::lookup", XS_Git__Raw__Tag_lookup, file);
        newXS("Git::Raw::Tag::foreach", XS_Git__Raw__Tag_foreach, file);
        newXS("Git::Raw::Tag::delete", XS_Git__Raw__Tag_delete, file);
        newXS("Git::Raw::Tag::id", XS_Git__Raw__Tag_id, file);
        newXS("Git::Raw::Tag::name", XS_Git__Raw__Tag_name, file);
        newXS("Git::Raw::Tag::message", XS_Git__Raw__Tag_message, file);
        newXS("Git::Raw::Tag::tagger", XS_Git__Raw__Tag_tagger, file);
        newXS("Git::Raw::Tag::target", XS_Git__Raw__Tag_target, file);
        newXS("Git::Raw::Tag::DESTROY", XS_Git__Raw__Tag_DESTROY, file);
        newXS("Git::Raw::Stash::save", XS_Git__Raw__Stash_save, file);
        newXS("Git::Raw::Stash::foreach", XS_Git__Raw__Stash_foreach, file);
        newXS("Git::Raw::Stash::drop", XS_Git__Raw__Stash_drop, file);
        newXS("Git::Raw::Signature::new", XS_Git__Raw__Signature_new, file);
        newXS("Git::Raw::Signature::now", XS_Git__Raw__Signature_now, file);
        newXS("Git::Raw::Signature::name", XS_Git__Raw__Signature_name, file);
        newXS("Git::Raw::Signature::email", XS_Git__Raw__Signature_email, file);
        newXS("Git::Raw::Signature::time", XS_Git__Raw__Signature_time, file);
        newXS("Git::Raw::Signature::offset", XS_Git__Raw__Signature_offset, file);
        newXS("Git::Raw::Signature::DESTROY", XS_Git__Raw__Signature_DESTROY, file);
        newXS("Git::Raw::Repository::init", XS_Git__Raw__Repository_init, file);
        newXS("Git::Raw::Repository::clone", XS_Git__Raw__Repository_clone, file);
        newXS("Git::Raw::Repository::open", XS_Git__Raw__Repository_open, file);
        newXS("Git::Raw::Repository::discover", XS_Git__Raw__Repository_discover, file);
        newXS("Git::Raw::Repository::config", XS_Git__Raw__Repository_config, file);
        newXS("Git::Raw::Repository::index", XS_Git__Raw__Repository_index, file);
        (void)newXSproto_portable("Git::Raw::Repository::head", XS_Git__Raw__Repository_head, file, "$;$");
        newXS("Git::Raw::Repository::lookup", XS_Git__Raw__Repository_lookup, file);
        newXS("Git::Raw::Repository::checkout", XS_Git__Raw__Repository_checkout, file);
        newXS("Git::Raw::Repository::reset", XS_Git__Raw__Repository_reset, file);
        newXS("Git::Raw::Repository::status", XS_Git__Raw__Repository_status, file);
        newXS("Git::Raw::Repository::ignore", XS_Git__Raw__Repository_ignore, file);
        (void)newXSproto_portable("Git::Raw::Repository::diff", XS_Git__Raw__Repository_diff, file, "$;$");
        newXS("Git::Raw::Repository::remotes", XS_Git__Raw__Repository_remotes, file);
        newXS("Git::Raw::Repository::path", XS_Git__Raw__Repository_path, file);
        (void)newXSproto_portable("Git::Raw::Repository::workdir", XS_Git__Raw__Repository_workdir, file, "$;$");
        newXS("Git::Raw::Repository::is_bare", XS_Git__Raw__Repository_is_bare, file);
        newXS("Git::Raw::Repository::is_empty", XS_Git__Raw__Repository_is_empty, file);
        newXS("Git::Raw::Repository::DESTROY", XS_Git__Raw__Repository_DESTROY, file);
        newXS("Git::Raw::Remote::create", XS_Git__Raw__Remote_create, file);
        (void)newXSproto_portable("Git::Raw::Remote::name", XS_Git__Raw__Remote_name, file, "$;$");
        (void)newXSproto_portable("Git::Raw::Remote::url", XS_Git__Raw__Remote_url, file, "$;$");
        newXS("Git::Raw::Remote::add_fetch", XS_Git__Raw__Remote_add_fetch, file);
        newXS("Git::Raw::Remote::add_push", XS_Git__Raw__Remote_add_push, file);
        newXS("Git::Raw::Remote::connect", XS_Git__Raw__Remote_connect, file);
        newXS("Git::Raw::Remote::disconnect", XS_Git__Raw__Remote_disconnect, file);
        newXS("Git::Raw::Remote::download", XS_Git__Raw__Remote_download, file);
        newXS("Git::Raw::Remote::save", XS_Git__Raw__Remote_save, file);
        newXS("Git::Raw::Remote::update_tips", XS_Git__Raw__Remote_update_tips, file);
        newXS("Git::Raw::Remote::cred_acquire", XS_Git__Raw__Remote_cred_acquire, file);
        newXS("Git::Raw::Remote::is_connected", XS_Git__Raw__Remote_is_connected, file);
        newXS("Git::Raw::Remote::DESTROY", XS_Git__Raw__Remote_DESTROY, file);
        newXS("Git::Raw::RefSpec::dst", XS_Git__Raw__RefSpec_dst, file);
        newXS("Git::Raw::RefSpec::src", XS_Git__Raw__RefSpec_src, file);
        newXS("Git::Raw::Reference::lookup", XS_Git__Raw__Reference_lookup, file);
        newXS("Git::Raw::Reference::delete", XS_Git__Raw__Reference_delete, file);
        newXS("Git::Raw::Reference::name", XS_Git__Raw__Reference_name, file);
        newXS("Git::Raw::Reference::type", XS_Git__Raw__Reference_type, file);
        newXS("Git::Raw::Reference::owner", XS_Git__Raw__Reference_owner, file);
        (void)newXSproto_portable("Git::Raw::Reference::target", XS_Git__Raw__Reference_target, file, "$");
        newXS("Git::Raw::Reference::is_branch", XS_Git__Raw__Reference_is_branch, file);
        newXS("Git::Raw::Reference::is_remote", XS_Git__Raw__Reference_is_remote, file);
        newXS("Git::Raw::Reference::DESTROY", XS_Git__Raw__Reference_DESTROY, file);
        newXS("Git::Raw::Push::new", XS_Git__Raw__Push_new, file);
        newXS("Git::Raw::Push::add_refspec", XS_Git__Raw__Push_add_refspec, file);
        newXS("Git::Raw::Push::finish", XS_Git__Raw__Push_finish, file);
        newXS("Git::Raw::Push::unpack_ok", XS_Git__Raw__Push_unpack_ok, file);
        newXS("Git::Raw::Push::DESTROY", XS_Git__Raw__Push_DESTROY, file);
        newXS("Git::Raw::Index::add", XS_Git__Raw__Index_add, file);
        newXS("Git::Raw::Index::clear", XS_Git__Raw__Index_clear, file);
        newXS("Git::Raw::Index::read", XS_Git__Raw__Index_read, file);
        newXS("Git::Raw::Index::write", XS_Git__Raw__Index_write, file);
        newXS("Git::Raw::Index::read_tree", XS_Git__Raw__Index_read_tree, file);
        newXS("Git::Raw::Index::write_tree", XS_Git__Raw__Index_write_tree, file);
        newXS("Git::Raw::Index::remove", XS_Git__Raw__Index_remove, file);
        newXS("Git::Raw::Index::DESTROY", XS_Git__Raw__Index_DESTROY, file);
        newXS("Git::Raw::Diff::merge", XS_Git__Raw__Diff_merge, file);
        newXS("Git::Raw::Diff::patch", XS_Git__Raw__Diff_patch, file);
        newXS("Git::Raw::Diff::compact", XS_Git__Raw__Diff_compact, file);
        newXS("Git::Raw::Diff::DESTROY", XS_Git__Raw__Diff_DESTROY, file);
        newXS("Git::Raw::Cred::plaintext", XS_Git__Raw__Cred_plaintext, file);
        newXS("Git::Raw::Cred::keyfile", XS_Git__Raw__Cred_keyfile, file);
        newXS("Git::Raw::Config::new", XS_Git__Raw__Config_new, file);
        newXS("Git::Raw::Config::add_file", XS_Git__Raw__Config_add_file, file);
        (void)newXSproto_portable("Git::Raw::Config::bool", XS_Git__Raw__Config_bool, file, "$$;$");
        (void)newXSproto_portable("Git::Raw::Config::int", XS_Git__Raw__Config_int, file, "$$;$");
        (void)newXSproto_portable("Git::Raw::Config::str", XS_Git__Raw__Config_str, file, "$$;$");
        newXS("Git::Raw::Config::foreach", XS_Git__Raw__Config_foreach, file);
        newXS("Git::Raw::Config::refresh", XS_Git__Raw__Config_refresh, file);
        newXS("Git::Raw::Config::delete", XS_Git__Raw__Config_delete, file);
        newXS("Git::Raw::Config::DESTROY", XS_Git__Raw__Config_DESTROY, file);
        newXS("Git::Raw::Commit::create", XS_Git__Raw__Commit_create, file);
        newXS("Git::Raw::Commit::lookup", XS_Git__Raw__Commit_lookup, file);
        newXS("Git::Raw::Commit::id", XS_Git__Raw__Commit_id, file);
        newXS("Git::Raw::Commit::message", XS_Git__Raw__Commit_message, file);
        newXS("Git::Raw::Commit::author", XS_Git__Raw__Commit_author, file);
        newXS("Git::Raw::Commit::committer", XS_Git__Raw__Commit_committer, file);
        newXS("Git::Raw::Commit::time", XS_Git__Raw__Commit_time, file);
        newXS("Git::Raw::Commit::offset", XS_Git__Raw__Commit_offset, file);
        newXS("Git::Raw::Commit::tree", XS_Git__Raw__Commit_tree, file);
        newXS("Git::Raw::Commit::parents", XS_Git__Raw__Commit_parents, file);
        newXS("Git::Raw::Commit::DESTROY", XS_Git__Raw__Commit_DESTROY, file);
        newXS("Git::Raw::Branch::create", XS_Git__Raw__Branch_create, file);
        newXS("Git::Raw::Branch::lookup", XS_Git__Raw__Branch_lookup, file);
        newXS("Git::Raw::Branch::move", XS_Git__Raw__Branch_move, file);
        newXS("Git::Raw::Branch::foreach", XS_Git__Raw__Branch_foreach, file);
        newXS("Git::Raw::Branch::upstream", XS_Git__Raw__Branch_upstream, file);
        newXS("Git::Raw::Branch::is_head", XS_Git__Raw__Branch_is_head, file);
        newXS("Git::Raw::Blob::create", XS_Git__Raw__Blob_create, file);
        newXS("Git::Raw::Blob::lookup", XS_Git__Raw__Blob_lookup, file);
        newXS("Git::Raw::Blob::content", XS_Git__Raw__Blob_content, file);
        newXS("Git::Raw::Blob::size", XS_Git__Raw__Blob_size, file);
        newXS("Git::Raw::Blob::DESTROY", XS_Git__Raw__Blob_DESTROY, file);

    /* Initialisation Section */

#line 4 "./xs/Branch.xs"
{
	AV *isa = perl_get_av("Git::Raw::Branch::ISA",1);
	av_push(isa, newSVpv("Git::Raw::Reference", 0));
}

#line 5056 "Raw.c"

    /* End of Initialisation Section */

#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

